import { c as J, a as Q, t as K, z as j, p as $, T as q, N as T, f as Z, I as ee, F as te, i as ae, Z as ie, W as re, _ as le, v as se, $ as ne, d as ce, B as oe, b as he, q as de, Q as ue, a0 as ge, r as fe, e as Ne, y as me, L as Ie, x as xe, a1 as be, o as Fe, s as _e, w as ye, E as Ae, A as Le, u as Ce } from "./index-mBy4elhB.js";
import { D as Se } from "./DataTable-BKc3r3k3.js";
import { _ as ke } from "./Title-CECK1w9L.js";
import { _ as we, u as Oe } from "./Tooltip-Ci3AprCm.js";
import { U as Ge } from "./usePrinter-Ck-yukK2.js";
import { _ as ve } from "./Shape-DPvoEBm9.js";
import pe from "./BaseIcon-DfaCNBgc.js";
import ze from "./vue-ui-table-sparkline-BeunspIj.js";
import Me from "./vue-ui-skeleton-DDhwPZd_.js";
import { S as Pe } from "./Slicer-DE9nFM_c.js";
import Te from "./vue-ui-accordion-dyF20BlD.js";
import { u as U } from "./useNestedProp-BrIRtQj1.js";
import { _ as Ve } from "./PackageVersion-D9PU8glB.js";
import { resolveComponent as V, openBlock as r, createElementBlock as l, normalizeClass as P, normalizeStyle as A, createBlock as R, createCommentVNode as h, createSlots as Re, withCtx as z, renderSlot as G, normalizeProps as B, guardReactiveProps as Y, createVNode as X, createElementVNode as u, Fragment as m, renderList as I, toDisplayString as S, withDirectives as De, vModelCheckbox as We, createTextVNode as He } from "vue";
import { _ as Ee } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Be = J(), Ye = {
  name: "vue-ui-xy",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  components: {
    DataTable: Se,
    Shape: ve,
    Title: ke,
    Tooltip: we,
    UserOptions: Ge,
    BaseIcon: pe,
    TableSparkline: ze,
    Skeleton: Me,
    Slicer: Pe,
    Accordion: Te,
    PackageVersion: Ve
  },
  data() {
    this.dataset.forEach((o, N) => {
      [null, void 0].includes(o.series) && this.error({
        componentName: "VueUiXy",
        type: "datasetSerieAttribute",
        property: "series (number[])",
        index: N
      });
    });
    const t = Math.max(...this.dataset.map((o) => o.series.length)), s = {
      start: 0,
      end: t
    };
    return {
      themePalettes: Q,
      themes: K,
      slicerStep: 0,
      selectedScale: null,
      CTX: null,
      CANVAS: null,
      opacity: j,
      useSafeValues: !0,
      palette: $,
      height: 600,
      width: 1e3,
      viewBox: "0 0 1000 600",
      clientPosition: {
        x: 0,
        y: 0
      },
      canvasClientPosition: {
        x: 0,
        y: 0
      },
      icons: {
        line: "line",
        bar: "bar",
        plot: "plot"
      },
      isFullscreen: !1,
      isPrinting: !1,
      isImaging: !1,
      isTooltip: !1,
      mutableConfig: {
        dataLabels: {
          show: !0
        },
        showTooltip: !0,
        showTable: !1,
        isStacked: !1,
        useIndividualScale: !1
      },
      selectedSerieIndex: null,
      selectedRowIndex: null,
      segregatedSeries: [],
      uniqueId: J(),
      step: 0,
      tableStep: 0,
      titleStep: 0,
      slicer: s,
      __to__: null,
      maxX: t,
      showSparklineTable: !0,
      segregateStep: 0,
      sliderId: Be,
      fontSizes: {
        xAxis: 18,
        yAxis: 12,
        dataLabels: 20,
        plotLabels: 10
      },
      plotRadii: {
        plot: 3,
        line: 3
      },
      selectedMinimapIndex: null
    };
  },
  watch: {
    dataset: {
      handler(t, s) {
        this.maxX = Math.max(...this.dataset.map((o) => o.series.length)), this.slicer = {
          start: 0,
          end: this.maxX
        }, this.slicerStep += 1, this.segregateStep += 1;
      },
      deep: !0
    },
    config: {
      handler(t, s) {
        this.FINAL_CONFIG = this.prepareConfig(), this.prepareChart(), this.titleStep += 1, this.tableStep += 1;
      },
      deep: !0
    }
  },
  computed: {
    minimap() {
      if (!this.FINAL_CONFIG.chart.zoom.minimap.show) return [];
      const t = this.datasetWithIds.filter((i) => !this.segregatedSeries.includes(i.id)), s = Math.max(...t.map((i) => i.series.length)), o = [];
      for (let i = 0; i < s; i += 1)
        o.push(t.map((e) => e.series[i] || 0).reduce((e, x) => (e || 0) + (x || 0), 0));
      const N = Math.min(...o);
      return o.map((i) => i + (N < 0 ? Math.abs(N) : 0));
    },
    customPalette() {
      return this.convertCustomPalette(this.FINAL_CONFIG.customPalette);
    },
    backgroundColor() {
      return this.FINAL_CONFIG.chart.backgroundColor;
    },
    slicerColor() {
      return this.FINAL_CONFIG.chart.zoom.color;
    },
    allScales() {
      const t = this.lineSet.map((i) => ({
        name: i.name,
        color: i.color,
        scale: i.individualScale,
        scaleYLabels: i.scaleYLabels,
        zero: i.zeroPosition,
        max: i.individualMax,
        scaleLabel: i.scaleLabel || "",
        id: i.id,
        yOffset: i.yOffset || 0,
        individualHeight: i.individualHeight || this.drawingArea.height,
        autoScaleYLabels: i.autoScaleYLabels
      })), s = this.barSet.map((i) => ({
        name: i.name,
        color: i.color,
        scale: i.individualScale,
        scaleYLabels: i.scaleYLabels,
        zero: i.zeroPosition,
        max: i.individualMax,
        scaleLabel: i.scaleLabel || "",
        id: i.id,
        yOffset: i.yOffset || 0,
        individualHeight: i.individualHeight || this.drawingArea.height
      })), o = this.plotSet.map((i) => ({
        name: i.name,
        color: i.color,
        scale: i.individualScale,
        scaleYLabels: i.scaleYLabels,
        // FIX
        zero: i.zeroPosition,
        max: i.individualMax,
        scaleLabel: i.scaleLabel || "",
        id: i.id,
        yOffset: i.yOffset || 0,
        individualHeight: i.individualHeight || this.drawingArea.height
      })), N = [...t, ...s, ...o].flatMap((i) => i).length;
      return [...t, ...s, ...o].flatMap((i, e) => ({
        id: i.id,
        scaleLabel: i.scaleLabel,
        name: i.name,
        color: i.color,
        scale: i.scale,
        yOffset: i.yOffset,
        individualHeight: i.individualHeight,
        x: this.mutableConfig.isStacked ? this.drawingArea.left : this.drawingArea.left / N * (e + 1),
        yLabels: i.scaleYLabels || i.scale.ticks.map((x) => ({
          y: x >= 0 ? i.zero - i.individualHeight * (x / i.max) : i.zero + i.individualHeight * Math.abs(x) / i.max,
          value: x
        }))
      }));
    },
    isDataset() {
      return !!this.dataset && this.dataset.length;
    },
    chartFont() {
      const t = document.getElementById(`vue-ui-xy_${this.uniqueId}`);
      return window.getComputedStyle(t, null).getPropertyValue("font-family");
    },
    FINAL_CONFIG: {
      get: function() {
        return this.prepareConfig();
      },
      set: function(t) {
        return t;
      }
    },
    hasHighlightArea() {
      return Array.isArray(this.FINAL_CONFIG.chart.highlightArea) ? this.FINAL_CONFIG.chart.highlightArea.some((t) => t.show) : this.FINAL_CONFIG.chart.highlightArea && this.FINAL_CONFIG.chart.highlightArea.show;
    },
    highlightAreas() {
      if (Array.isArray(this.FINAL_CONFIG.chart.highlightArea))
        return this.FINAL_CONFIG.chart.highlightArea.map((s) => ({
          ...s,
          span: s.from === s.to ? 1 : s.to < s.from ? 0 : s.to - s.from + 1
        }));
      const t = this.FINAL_CONFIG.chart.highlightArea;
      return [{ ...t, span: t.from === t.to ? 1 : t.to < t.from ? 0 : t.to - t.from + 1 }];
    },
    xPadding() {
      return this.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : this.drawingArea.width / this.maxSeries / 2;
    },
    relativeZero() {
      return this.niceScale.min >= 0 ? 0 : Math.abs(this.niceScale.min);
    },
    absoluteMax() {
      return this.niceScale.max + this.relativeZero;
    },
    datasetWithIds() {
      return this.useSafeValues ? this.dataset.map((t, s) => ({
        ...t,
        id: `uniqueId_${s}`
      })) : this.dataset;
    },
    safeDataset() {
      return this.useSafeValues ? this.dataset.map((t, s) => ({
        ...t,
        series: t.series.map((o) => this.isSafeValue(o) ? o : null).slice(this.slicer.start, this.slicer.end),
        color: this.convertColorToHex(t.color ? t.color : this.customPalette[s] ? this.customPalette[s] : this.palette[s]),
        id: `uniqueId_${s}`
      })) : this.dataset;
    },
    relativeDataset() {
      return this.safeDataset.map((t, s) => ({
        ...t,
        series: t.series.map((o) => o + this.relativeZero),
        absoluteValues: t.series
      })).filter((t) => !this.segregatedSeries.includes(t.id));
    },
    tableSparklineDataset() {
      return this.relativeDataset.map((t) => {
        const s = t.absoluteValues.map((o) => [void 0, null].includes(o) ? 0 : o);
        return {
          id: t.id,
          name: t.name,
          color: t.color,
          values: this.fillArray(this.maxSeries, s)
        };
      });
    },
    tableSparklineConfig() {
      return {
        responsiveBreakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint,
        roundingValues: this.FINAL_CONFIG.table.rounding,
        showAverage: !1,
        showMedian: !1,
        showTotal: !1,
        fontFamily: this.FINAL_CONFIG.chart.fontFamily,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix,
        colNames: JSON.parse(JSON.stringify(this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values)),
        thead: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        tbody: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        userOptions: {
          show: !1
        }
      };
    },
    absoluteDataset() {
      return this.safeDataset.map((t, s) => ({
        absoluteIndex: s,
        ...t,
        series: t.series.map((o) => o + this.relativeZero),
        absoluteValues: t.series,
        segregate: () => this.segregate(t),
        isSegregated: this.segregatedSeries.includes(t.id)
      }));
    },
    barSet() {
      return this.activeSeriesWithStackRatios.filter((t) => t.type === "bar").map((t, s) => {
        this.checkAutoScaleError(t);
        const o = Math.min(...t.absoluteValues.filter((d) => ![null, void 0].includes(d))), N = Math.max(...t.absoluteValues.filter((d) => ![null, void 0].includes(d))), e = {
          ratios: t.absoluteValues.filter((d) => ![null, void 0].includes(d)).map((d) => (d - o) / (N - o)),
          valueMin: o,
          valueMax: N < 0 ? 0 : N
        }, x = {
          max: t.scaleMax || Math.max(...t.absoluteValues) || 1,
          min: t.scaleMin || Math.min(...t.absoluteValues.filter((d) => ![void 0, null].includes(d))) > 0 ? 0 : Math.min(...t.absoluteValues.filter((d) => ![null, void 0].includes(d)))
        }, _ = t.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, k = 1.0000001, f = this.calculateNiceScaleWithExactExtremes(x.min, x.max === x.min ? x.max * k : x.max, _), L = this.calculateNiceScaleWithExactExtremes(e.valueMin, e.valueMax === e.valueMin ? e.valueMax * k : e.valueMax, _), M = f.min >= 0 ? 0 : Math.abs(f.min), w = 0, p = f.max + M, v = L.max + Math.abs(w), F = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - t.cumulatedStackRatio) : 0, C = this.mutableConfig.isStacked ? this.drawingArea.height * t.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, a = this.drawingArea.bottom - F - C * M / p, c = this.drawingArea.bottom - F - C * w / v, n = this.absoluteDataset.filter((d) => d.type === "bar").filter((d) => !this.segregatedSeries.includes(d.id)).length, g = t.series.map((d, b) => {
          const H = this.mutableConfig.useIndividualScale ? (t.absoluteValues[b] + M) / p : this.ratioToMax(d), E = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * b : this.drawingArea.left + this.slot.bar * s + this.slot.bar * b * n - this.barSlot / 2 - s * this.barPeriodGap;
          return {
            yOffset: this.checkNaN(F),
            individualHeight: this.checkNaN(C),
            x: this.checkNaN(E),
            y: this.drawingArea.bottom - F - C * H,
            value: t.absoluteValues[b],
            zeroPosition: this.checkNaN(a),
            individualMax: this.checkNaN(p),
            comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[b] || ""
          };
        }), W = t.absoluteValues.map((d) => L.min >= 0 ? (d - Math.abs(L.min)) / (L.max - Math.abs(L.min)) : (d + Math.abs(L.min)) / (L.max + Math.abs(L.min))), D = t.series.map((d, b) => {
          const H = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * b : this.drawingArea.left - this.slot.bar / 2 + this.slot.bar * s + this.slot.bar * b * this.absoluteDataset.filter((E) => E.type === "bar").filter((E) => !this.segregatedSeries.includes(E.id)).length;
          return {
            yOffset: this.checkNaN(F),
            individualHeight: this.checkNaN(C),
            x: this.checkNaN(H),
            y: this.checkNaN(this.drawingArea.bottom - this.checkNaN(F) - (this.checkNaN(C) * W[b] || 0)),
            value: t.absoluteValues[b],
            zeroPosition: this.checkNaN(a),
            individualMax: this.checkNaN(p),
            comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[b] || ""
          };
        }), y = f.ticks.map((d) => ({
          y: d >= 0 ? a - C * (d / p) : a + C * Math.abs(d) / p,
          value: d,
          prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: t
        })), O = L.ticks.map((d) => {
          const b = (d - L.min) / (L.max - L.min);
          return {
            y: d >= 0 ? c - C * b : c + C * b,
            value: d,
            prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: t
          };
        });
        return {
          ...t,
          yOffset: F,
          autoScaleYLabels: O,
          individualHeight: C,
          scaleYLabels: t.autoScaling ? O : y,
          individualScale: t.autoScaling ? L : f,
          individualMax: t.autoScaling ? v : p,
          zeroPosition: t.autoScaling ? c : a,
          plots: t.autoScaling ? D : g
        };
      });
    },
    activeSeriesLength() {
      return this.absoluteDataset.length;
    },
    activeSeriesWithStackRatios() {
      return this.assignStackRatios(this.absoluteDataset.filter((t) => !this.segregatedSeries.includes(t.id)));
    },
    lineSet() {
      return this.activeSeriesWithStackRatios.filter((t) => t.type === "line").map((t) => {
        this.checkAutoScaleError(t);
        const s = Math.min(...t.absoluteValues.filter((d) => ![void 0, null].includes(d))), o = Math.max(...t.absoluteValues.filter((d) => ![void 0, null].includes(d))) || 1, i = {
          ratios: t.absoluteValues.filter((d) => ![null, void 0].includes(d)).map((d) => (d - s) / (o - s)),
          valueMin: s,
          valueMax: o
        }, e = {
          max: t.scaleMax || Math.max(...t.absoluteValues) || 1,
          min: t.scaleMin || (Math.min(...t.absoluteValues) > 0 ? 0 : Math.min(...t.absoluteValues))
        }, x = t.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, _ = 1.0000001, k = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * _ : e.max, x), f = this.calculateNiceScaleWithExactExtremes(i.valueMin, i.valueMax === i.valueMin ? i.valueMax * _ : i.valueMax, x), L = k.min >= 0 ? 0 : Math.abs(k.min), M = 0, w = k.max + Math.abs(L), p = f.max + Math.abs(M), v = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - t.cumulatedStackRatio) : 0, F = this.mutableConfig.isStacked ? this.drawingArea.height * t.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, C = this.drawingArea.bottom - v - F * L / w, a = this.drawingArea.bottom - v - F * M / p, c = t.series.map((d, b) => {
          const H = this.mutableConfig.useIndividualScale ? (t.absoluteValues[b] + Math.abs(L)) / w : this.ratioToMax(d);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * b),
            y: this.checkNaN(this.drawingArea.bottom - v - F * H),
            value: t.absoluteValues[b],
            comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[b] || ""
          };
        }), n = t.absoluteValues.map((d) => f.min >= 0 ? (d - Math.abs(f.min)) / (f.max - Math.abs(f.min)) : (d + Math.abs(f.min)) / (f.max + Math.abs(f.min))), g = t.series.map((d, b) => [void 0, null].includes(t.absoluteValues[b]) ? {
          x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * b),
          y: C,
          value: t.absoluteValues[b],
          comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[b] || ""
        } : {
          x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * b),
          y: this.checkNaN(this.drawingArea.bottom - v - (F * n[b] || 0)),
          value: t.absoluteValues[b],
          comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[b] || ""
        }), W = this.createSmoothPath(c), D = this.createSmoothPath(g), y = k.ticks.map((d) => ({
          y: d >= 0 ? C - F * (d / w) : C + F * Math.abs(d) / w,
          value: d,
          prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: t
        })), O = f.ticks.map((d) => {
          const b = (d - f.min) / (f.max - f.min);
          return {
            y: d >= 0 ? a - F * b : a + F * b,
            value: d,
            prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: t
          };
        });
        return {
          ...t,
          yOffset: v,
          autoScaleYLabels: O,
          individualHeight: F,
          scaleYLabels: t.autoScaling ? O : y,
          individualScale: t.autoScaling ? f : k,
          individualMax: t.autoScaling ? p : w,
          zeroPosition: t.autoScaling ? a : C,
          curve: t.autoScaling ? D : W,
          plots: t.autoScaling ? g : c,
          area: t.useArea ? this.mutableConfig.useIndividualScale ? this.createIndividualArea(t.autoScaling ? g : c, t.autoScaling ? a : C) : this.createArea(c) : ""
        };
      });
    },
    plotSet() {
      return this.activeSeriesWithStackRatios.filter((t) => t.type === "plot").map((t) => {
        this.checkAutoScaleError(t);
        const s = Math.min(...t.absoluteValues.filter((y) => ![null, void 0].includes(y))), o = Math.max(...t.absoluteValues.filter((y) => ![null, void 0].includes(y))) || 1, i = {
          ratios: t.absoluteValues.filter((y) => ![null, void 0].includes(y)).map((y) => (y - s) / (o - s)),
          valueMin: s,
          valueMax: o
        }, e = {
          max: t.scaleMax || Math.max(...t.absoluteValues) || 1,
          min: t.scaleMin || Math.min(...t.absoluteValues) > 0 ? 0 : Math.min(...t.absoluteValues)
        }, x = t.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, _ = 1.0000001, k = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * _ : e.max, x), f = this.calculateNiceScaleWithExactExtremes(i.valueMin, i.valueMax === i.valueMin ? i.valueMax * _ : i.valueMax, x), L = k.min >= 0 ? 0 : Math.abs(k.min), M = 0, w = k.max + L, p = f.max + Math.abs(M), v = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - t.cumulatedStackRatio) : 0, F = this.mutableConfig.isStacked ? this.drawingArea.height * t.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, C = this.drawingArea.bottom - v - F * L / w, a = this.drawingArea.bottom - v - F * M / p, c = t.series.map((y, O) => {
          const d = this.mutableConfig.useIndividualScale ? (t.absoluteValues[O] + Math.abs(L)) / w : this.ratioToMax(y);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * O),
            y: this.checkNaN(this.drawingArea.bottom - v - F * d),
            value: t.absoluteValues[O],
            comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[O] || ""
          };
        }), n = t.absoluteValues.map((y) => f.min >= 0 ? (y - Math.abs(f.min)) / (f.max - Math.abs(f.min)) : (y + Math.abs(f.min)) / (f.max + Math.abs(f.min))), g = t.series.map((y, O) => ({
          x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * O),
          y: this.checkNaN(this.drawingArea.bottom - v - (F * n[O] || 0)),
          value: t.absoluteValues[O],
          comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[O] || ""
        })), W = k.ticks.map((y) => ({
          y: y >= 0 ? C - F * (y / w) : C + F * Math.abs(y) / w,
          value: y,
          prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: t
        })), D = f.ticks.map((y) => {
          const O = (y - f.min) / (f.max - f.min);
          return {
            y: y >= 0 ? a - F * O : a + F * O,
            value: y,
            prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: t
          };
        });
        return {
          ...t,
          yOffset: v,
          autoScaleYLabels: D,
          individualHeight: F,
          scaleYLabels: t.autoScaling ? D : W,
          individualScale: t.autoScaling ? f : k,
          individualMax: t.autoScaling ? p : w,
          zeroPosition: t.autoScaling ? a : C,
          plots: t.autoScaling ? g : c
        };
      });
    },
    drawingArea() {
      const t = this.mutableConfig.useIndividualScale && this.FINAL_CONFIG.chart.grid.labels.show ? this.absoluteDataset.filter((s) => !this.segregatedSeries.includes(s.id)).length * (this.mutableConfig.isStacked ? 0 : this.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth) : 0;
      return {
        top: this.FINAL_CONFIG.chart.padding.top,
        right: this.width - this.FINAL_CONFIG.chart.padding.right,
        bottom: this.height - this.FINAL_CONFIG.chart.padding.bottom,
        left: this.FINAL_CONFIG.chart.padding.left + t,
        height: this.height - (this.FINAL_CONFIG.chart.padding.top + this.FINAL_CONFIG.chart.padding.bottom),
        width: this.width - (this.FINAL_CONFIG.chart.padding.right + this.FINAL_CONFIG.chart.padding.left + t)
      };
    },
    max() {
      return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax ? this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax : Math.max(...this.safeDataset.filter((t) => !this.segregatedSeries.includes(t.id)).map((t) => Math.max(...t.series)));
    },
    min() {
      if (this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin !== null)
        return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin;
      const t = Math.min(...this.safeDataset.filter((s) => !this.segregatedSeries.includes(s.id)).map((s) => Math.min(...s.series)));
      return t > 0 ? 0 : t;
    },
    niceScale() {
      return this.calculateNiceScaleWithExactExtremes(this.min, this.max < 0 ? 0 : this.max, this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps);
    },
    maxSeries() {
      return this.slicer.end - this.slicer.start;
    },
    timeLabels() {
      return this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values.slice(this.slicer.start, this.slicer.end);
    },
    slot() {
      return {
        bar: this.drawingArea.width / this.maxSeries / this.safeDataset.filter((t) => t.type === "bar").filter((t) => !this.segregatedSeries.includes(t.id)).length,
        plot: this.drawingArea.width / this.maxSeries,
        line: this.drawingArea.width / this.maxSeries
      };
    },
    barSlot() {
      const t = this.safeDataset.filter((s) => s.type === "bar").filter((s) => !this.segregatedSeries.includes(s.id)).length;
      return this.drawingArea.width / this.maxSeries / t - this.barPeriodGap * t;
    },
    barPeriodGap() {
      return this.slot.line * this.FINAL_CONFIG.bar.periodGap;
    },
    maxSlot() {
      return Math.max(...Object.values(this.slot).filter((t) => t !== 1 / 0));
    },
    table() {
      if (this.safeDataset.length === 0) return { head: [], body: [], config: {}, columnNames: [] };
      const t = this.relativeDataset.map((o) => ({
        label: o.name,
        color: o.color,
        type: o.type
      })), s = [];
      return this.timeLabels.forEach((o, N) => {
        const i = [o];
        this.relativeDataset.forEach((e) => {
          i.push(this.canShowValue(e.absoluteValues[N]) ? Number(e.absoluteValues[N].toFixed(this.FINAL_CONFIG.table.rounding)) : "");
        }), s.push(i);
      }), { head: t, body: s };
    },
    dataTable() {
      const t = this.FINAL_CONFIG.table.showSum;
      let s = [""].concat(this.relativeDataset.map((e) => e.name));
      t && (s = s.concat(' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>'));
      let o = [];
      for (let e = 0; e < this.maxSeries; e += 1) {
        const x = this.relativeDataset.map((_) => _.absoluteValues[e] ?? 0).reduce((_, k) => _ + k, 0);
        o.push(
          [
            this.timeLabels[e] ?? "-"
          ].concat(this.relativeDataset.map(
            (_) => this.applyDataLabel(
              _.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : _.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
              _.absoluteValues[e] ?? 0,
              this.dataLabel({
                p: _.prefix || this.FINAL_CONFIG.chart.labels.prefix,
                v: _.absoluteValues[e] ?? 0,
                s: _.suffix || this.FINAL_CONFIG.chart.labels.suffix,
                r: this.FINAL_CONFIG.table.rounding
              })
            )
          )).concat(t ? (x ?? 0).toFixed(this.FINAL_CONFIG.table.rounding) : [])
        );
      }
      const N = {
        th: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        td: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        breakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint
      }, i = [this.FINAL_CONFIG.table.columnNames.period].concat(this.relativeDataset.map((e) => e.name)).concat(this.FINAL_CONFIG.table.columnNames.total);
      return { head: s, body: o, config: N, colNames: i };
    },
    dataTooltipSlot() {
      return {
        datapoint: this.selectedSeries,
        seriesIndex: this.selectedSerieIndex,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      };
    },
    selectedSeries() {
      return this.relativeDataset.map((t) => ({
        shape: t.shape || null,
        name: t.name,
        color: t.color,
        type: t.type,
        value: t.absoluteValues.find((s, o) => o === this.selectedSerieIndex),
        comments: t.comments || [],
        prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
        suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix
      }));
    },
    tooltipContent() {
      let t = "", s = this.selectedSeries.map((i) => i.value).filter((i) => this.isSafeValue(i) && i !== null).reduce((i, e) => Math.abs(i) + Math.abs(e), 0);
      const o = this.timeLabels[this.selectedSerieIndex], N = this.FINAL_CONFIG.chart.tooltip.customFormat;
      return this.isFunction(N) && this.functionReturnsString(() => N({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      })) ? N({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      }) : (o && (t += `<div style="padding-bottom: 6px; margin-bottom: 4px; border-bottom: 1px solid ${this.FINAL_CONFIG.chart.tooltip.borderColor}; width:100%">${o}</div>`), this.selectedSeries.forEach((i) => {
        if (this.isSafeValue(i.value)) {
          let e = "", x = "";
          switch (this.icons[i.type]) {
            case "bar":
              e = `<svg viewBox="0 0 12 12" height="14" width="14"><rect x="0" y="0" rx="1" stroke="none" height="12" width="12" fill="${i.color}" /></svg>`;
              break;
            case "line":
              !i.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(i.shape) ? x = `<circle cx="10" cy="8" r="4" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${i.color}" />` : i.shape === "triangle" ? x = `<path d="${T({ plot: { x: 10, y: 8 }, radius: 4, sides: 3, rotation: 0.52 }).path}" fill="${i.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : i.shape === "square" ? x = `<path d="${T({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0.8 }).path}" fill="${i.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : i.shape === "diamond" ? x = `<path d="${T({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0 }).path}" fill="${i.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : i.shape === "pentagon" ? x = `<path d="${T({ plot: { x: 10, y: 8 }, radius: 4, sides: 5, rotation: 0.95 }).path}" fill="${i.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : i.shape === "hexagon" ? x = `<path d="${T({ plot: { x: 10, y: 8 }, radius: 4, sides: 6, rotation: 0 }).path}" fill="${i.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : i.shape === "star" && (x = `<polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${i.color}" points="${q({ plot: { x: 10, y: 8 }, radius: 4 })}" />`), e = `<svg viewBox="0 0 20 12" height="14" width="20"><rect rx="3" x="0" y="6" stroke="none" height="4" width="20" fill="${i.color}" />${x}</svg>`;
              break;
            case "plot":
              if (!i.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(i.shape)) {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${i.color}" /></svg>`;
                break;
              }
              if (i.shape === "star") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${i.color}" points="${q({ plot: { x: 6, y: 6 }, radius: 5 })}" /></svg>`;
                break;
              }
              if (i.shape === "triangle") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${T({ plot: { x: 6, y: 6 }, radius: 6, sides: 3, rotation: 0.52 }).path}" fill="${i.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (i.shape === "square") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${T({ plot: { x: 6, y: 6 }, radius: 6, sides: 4, rotation: 0.8 }).path}" fill="${i.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (i.shape === "diamond") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${T({ plot: { x: 6, y: 6 }, radius: 5, sides: 4, rotation: 0 }).path}" fill="${i.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (i.shape === "pentagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${T({ plot: { x: 6, y: 6 }, radius: 5, sides: 5, rotation: 0.95 }).path}" fill="${i.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (i.shape === "hexagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${T({ plot: { x: 6, y: 6 }, radius: 5, sides: 6, rotation: 0 }).path}" fill="${i.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
          }
          t += `<div style="display:flex;flex-direction:row; align-items:center;gap:3px;"><div style="width:20px">${e}</div> ${i.name}: <b>${this.FINAL_CONFIG.chart.tooltip.showValue ? this.applyDataLabel(
            i.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : i.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
            i.value,
            this.dataLabel({
              p: i.prefix,
              v: i.value,
              s: i.suffix,
              r: this.FINAL_CONFIG.chart.tooltip.roundingValue
            }),
            { datapoint: i }
          ) : ""}</b> ${this.FINAL_CONFIG.chart.tooltip.showPercentage ? `(${Z({
            v: this.checkNaN(Math.abs(i.value) / s * 100),
            s: "%",
            r: this.FINAL_CONFIG.chart.tooltip.roundingPercentage
          })})` : ""}</div>`, this.FINAL_CONFIG.chart.comments.showInTooltip && i.comments.length && i.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex] && (t += `<div class="vue-data-ui-tooltip-comment" style="background:${i.color}20; padding: 6px; margin-bottom: 6px; border-left: 1px solid ${i.color}">${i.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex]}</div>`);
        }
      }), `<div style="border-radius:4px;padding:12px;font-variant-numeric: tabular-nums;color:${this.FINAL_CONFIG.chart.tooltip.color}">${t}</div>`);
    },
    svg() {
      return {
        height: this.height,
        width: this.width
      };
    },
    yLabels() {
      return this.niceScale.ticks.map((t) => ({
        y: t >= 0 ? this.zero - this.drawingArea.height * this.ratioToMax(t) : this.zero + this.drawingArea.height * this.ratioToMax(Math.abs(t)),
        value: t,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix
      }));
    },
    zero() {
      return this.drawingArea.bottom - this.drawingArea.height * this.ratioToMax(this.relativeZero);
    }
  },
  mounted() {
    this.prepareChart(), document.addEventListener("mousemove", (t) => {
      this.clientPosition = {
        x: t.clientX,
        y: t.clientY
      };
    });
  },
  methods: {
    abbreviate: ee,
    adaptColorToBackground: te,
    applyDataLabel: ae,
    assignStackRatios: ie,
    calcLinearProgression: re,
    calculateNiceScaleWithExactExtremes: le,
    checkNaN: se,
    closestDecimal: ne,
    convertColorToHex: ce,
    convertConfigColors: oe,
    convertCustomPalette: he,
    createCsvContent: de,
    createSmoothPath: ue,
    createTSpans: ge,
    dataLabel: Z,
    downloadCsv: fe,
    error: Ne,
    functionReturnsString: me,
    hasDeepProperty: Ie,
    isFunction: xe,
    isSafeValue: be,
    objectIsEmpty: Fe,
    setOpacity: _e,
    shiftHue: ye,
    translateSize: Ae,
    treeShake: Le,
    useMouse: Oe,
    useNestedProp: U,
    getHighlightAreaPosition(t) {
      const s = this.drawingArea.left + this.drawingArea.width / this.maxSeries * (t.from - this.slicer.start), o = this.drawingArea.width / (this.slicer.end - this.slicer.start) * t.span < 0 ? 1e-5 : this.drawingArea.width / (this.slicer.end - this.slicer.start) * t.span;
      return {
        x: s < this.drawingArea.left ? this.drawingArea.left : s,
        width: o
      };
    },
    prepareConfig() {
      const t = Ce().vue_ui_xy;
      if (!Object.keys(this.config || {}).length)
        return t;
      const s = this.useNestedProp({
        userConfig: this.config,
        defaultConfig: t
      });
      return this.config && this.hasDeepProperty(this.config, "chart.highlightArea") && (Array.isArray(this.config.chart.highlightArea) ? s.chart.highlightArea = this.config.chart.highlightArea : s.chart.highlightArea = [this.config.chart.highlightArea]), this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMin") ? s.chart.grid.labels.yAxis.scaleMin = this.config.chart.grid.labels.yAxis.scaleMin : s.chart.grid.labels.yAxis.scaleMin = null, this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMax") ? s.chart.grid.labels.yAxis.scaleMax = this.config.chart.grid.labels.yAxis.scaleMax : s.chart.grid.labels.yAxis.scaleMax = null, s.theme ? {
        ...U({
          userConfig: this.themes.vue_ui_xy[s.theme] || this.config,
          defaultConfig: s
        }),
        customPalette: this.themePalettes[s.theme] || this.palette
      } : s;
    },
    prepareChart() {
      if (this.objectIsEmpty(this.dataset) ? this.error({
        componentName: "VueUiXy",
        type: "dataset"
      }) : this.dataset.forEach((t, s) => {
        [null, void 0].includes(t.name) && this.error({
          componentName: "VueUiXy",
          type: "datasetSerieAttribute",
          property: "name (string)",
          index: s
        });
      }), this.FINAL_CONFIG.showWarnings && this.dataset.forEach((t) => {
        t.series.forEach((s, o) => {
          this.isSafeValue(s) || console.warn(`VueUiXy has detected an unsafe value in your dataset:
-----> The serie '${t.name}' contains the value '${s}' at index ${o}.
'${s}' was converted to null to allow the chart to display.`);
        });
      }), this.mutableConfig = {
        dataLabels: {
          show: !0
        },
        showTooltip: this.FINAL_CONFIG.chart.tooltip.show === !0,
        showTable: this.FINAL_CONFIG.showTable === !0,
        isStacked: this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked,
        useIndividualScale: this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale
      }, this.FINAL_CONFIG.responsive) {
        const s = this.$refs.chart.parentNode, { height: o, width: N } = s.getBoundingClientRect();
        let i = null, e = 0;
        this.FINAL_CONFIG.chart.title.show && (i = this.$refs.chartTitle, e = i.getBoundingClientRect().height);
        let x = null, _ = 0;
        this.FINAL_CONFIG.chart.zoom.show && this.maxX > 6 && this.isDataset && (x = this.$refs.chartSlicer.$el, _ = x.getBoundingClientRect().height);
        let k = null, f = 0;
        this.FINAL_CONFIG.chart.legend.show && (k = this.$refs.chartLegend, f = k.getBoundingClientRect().height), this.height = o - e - f - _, this.width = N, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes(), new ResizeObserver((M) => {
          for (const w of M)
            this.$refs.chartTitle && (e = this.$refs.chartTitle.getBoundingClientRect().height), this.$refs.chartSlicer && this.$refs.chartSlicer.$el && (_ = this.$refs.chartSlicer.$el.getBoundingClientRect().height), this.$refs.chartLegend && (f = this.$refs.chartLegend.getBoundingClientRect().height), this.height = w.contentBoxSize[0].blockSize - e - f - _ - 24, this.width = w.contentBoxSize[0].inlineSize, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes();
        }).observe(s);
      } else
        this.height = this.FINAL_CONFIG.chart.height, this.width = this.FINAL_CONFIG.chart.width, this.viewBox = `0 0 ${this.width} ${this.height}`, this.fontSizes.dataLabels = this.FINAL_CONFIG.chart.grid.labels.fontSize, this.fontSizes.yAxis = this.FINAL_CONFIG.chart.grid.labels.axis.fontSize, this.fontSizes.xAxis = this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize, this.fontSizes.plotLabels = this.FINAL_CONFIG.chart.labels.fontSize, this.plotRadii.plot = this.FINAL_CONFIG.plot.radius, this.plotRadii.line = this.FINAL_CONFIG.line.radius;
    },
    selectMinimapIndex(t) {
      this.selectedMinimapIndex = t;
    },
    convertSizes() {
      this.fontSizes.dataLabels = this.translateSize({
        relator: this.height,
        adjuster: 400,
        source: this.FINAL_CONFIG.chart.grid.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.yAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.axis.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.xAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.plotLabels = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.chart.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.plotRadii.plot = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.plot.radius,
        threshold: 1,
        fallback: 1
      }), this.plotRadii.line = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.line.radius,
        threshold: 1,
        fallback: 1
      });
    },
    toggleStack() {
      this.mutableConfig.isStacked = !this.mutableConfig.isStacked, this.mutableConfig.isStacked ? this.mutableConfig.useIndividualScale = !0 : this.mutableConfig.useIndividualScale = this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale;
    },
    toggleTable() {
      this.mutableConfig.showTable = !this.mutableConfig.showTable;
    },
    toggleLabels() {
      this.mutableConfig.dataLabels.show = !this.mutableConfig.dataLabels.show;
    },
    toggleTooltip() {
      this.mutableConfig.showTooltip = !this.mutableConfig.showTooltip;
    },
    checkAutoScaleError(t) {
      t.autoScaling && (this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale || console.warn(`VueUiXy (datapoint: ${t.name}) : autoScaling only works when config.chart.grid.labels.yAxis.useIndividualScale is set to true`), this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked || console.warn(`VueUiXy (datapoint: ${t.name}) : autoScaling only works when config.chart.grid.labels.yAxis.stacked is set to true`));
    },
    createArea(t) {
      if (!t[0]) return [-10, -10, "", -10, -10];
      const s = { x: t[0].x, y: this.zero }, o = { x: t.at(-1).x, y: this.zero }, N = [];
      return t.forEach((i) => {
        N.push(`${i.x},${i.y} `);
      }), [s.x, s.y, ...N, o.x, o.y].toString();
    },
    createIndividualArea(t, s) {
      if (!t[0]) return [-10, -10, "", -10, -10];
      const o = { x: t[0] ? t[0].x : Math.min(...t.filter((e) => !!e).map((e) => e.x)), y: s }, N = { x: t.at(-1) ? t.at(-1).x : Math.min(...t.filter((e) => !!e).map((e) => e.x)), y: s }, i = [];
      return t.filter((e) => !!e).forEach((e) => {
        i.push(`${e.x},${e.y} `);
      }), [o.x, o.y, ...i, N.x, N.y].toString();
    },
    createStar: q,
    createPolygonPath: T,
    fillArray(t, s) {
      let o = Array(t).fill(0);
      for (let N = 0; N < s.length && N < t; N += 1)
        o[N] = s[N];
      return o;
    },
    refreshSlicer() {
      this.slicer = {
        start: 0,
        end: Math.max(...this.dataset.map((t) => t.series.length))
      }, this.slicerStep += 1;
    },
    calcRectHeight(t) {
      return t.value >= 0 ? this.checkNaN(this.zero - t.y <= 0 ? 1e-5 : this.zero - t.y) : this.checkNaN(t.y - this.zero <= 0 ? 1e-5 : t.y - this.zero);
    },
    calcIndividualHeight(t) {
      return t.value >= 0 ? this.checkNaN(t.zeroPosition - t.y <= 0 ? 1e-5 : t.zeroPosition - t.y) : this.checkNaN(t.y - t.zeroPosition <= 0 ? 1e-5 : t.zeroPosition - t.y);
    },
    calcRectWidth() {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.slot.line - this.drawingArea.width / this.maxSeries * 0.1 : this.slot.bar;
    },
    calcRectX(t) {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? t.x + this.drawingArea.width / this.maxSeries * 0.05 : t.x + this.slot.bar / 2;
    },
    calcRectY(t) {
      return t.value >= 0 ? t.y : this.zero;
    },
    calcIndividualRectY(t) {
      return t.value >= 0 ? t.y : [null, void 0, NaN, 1 / 0, -1 / 0].includes(t.zeroPosition) ? 0 : t.zeroPosition;
    },
    canShowValue(t) {
      return ![null, void 0, NaN, 1 / 0, -1 / 0].includes(t);
    },
    findClosestValue(t, s) {
      let o = s[0], N = Math.abs(t - s[0]);
      for (let i = 1; i < s.length; i += 1) {
        const e = Math.abs(t - s[i]);
        e < N && s[i] < t && (o = s[i], N = e);
      }
      return o;
    },
    ratioToMax(t) {
      return t / (this.canShowValue(this.absoluteMax) ? this.absoluteMax : 1);
    },
    selectX(t) {
      this.$emit(
        "selectX",
        {
          dataset: this.relativeDataset.map((s) => ({
            name: s.name,
            value: [null, void 0, NaN].includes(s.absoluteValues[t]) ? null : s.absoluteValues[t],
            color: s.color,
            type: s.type
          })),
          index: t,
          indexLabel: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t]
        }
      );
    },
    getData() {
      return this.absoluteDataset.map((t) => ({
        values: t.absoluteValues,
        color: t.color,
        name: t.name,
        type: t.type
      }));
    },
    segregate(t) {
      if (this.segregatedSeries.includes(t.id))
        this.segregatedSeries = this.segregatedSeries.filter((s) => s !== t.id);
      else {
        if (this.segregatedSeries.length + 1 === this.safeDataset.length) return;
        this.segregatedSeries.push(t.id);
      }
      this.$emit("selectLegend", this.relativeDataset.map((s) => ({
        name: s.name,
        values: s.absoluteValues,
        color: s.color,
        type: s.type
      }))), this.segregateStep += 1;
    },
    toggleTooltipVisibility(t, s = null) {
      this.isTooltip = t, t ? this.selectedSerieIndex = s : this.selectedSerieIndex = null;
    },
    toggleFullscreen(t) {
      this.isFullscreen = t, this.step += 1;
    },
    showSpinnerPdf() {
      this.isPrinting = !0;
    },
    async generatePdf() {
      this.showSpinnerPdf(), clearTimeout(this.__to__), this.isPrinting = !0, this.__to__ = setTimeout(async () => {
        try {
          const { default: t } = await import("./pdf-B7oVat64.js");
          await t({
            domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
            fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy"
          });
        } catch (t) {
          console.error("Error generating PDF:", t);
        } finally {
          this.isPrinting = !1;
        }
      }, 100);
    },
    generateCsv() {
      const t = [[this.FINAL_CONFIG.chart.title.text], [this.FINAL_CONFIG.chart.title.subtitle.text], [""]], s = ["", ...this.table.head.map((e) => e.label)], o = this.table.body, N = t.concat([s]).concat(o), i = this.createCsvContent(N);
      this.downloadCsv({ csvContent: i, title: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy" });
    },
    showSpinnerImage() {
      this.isImaging = !0;
    },
    async generateImage() {
      this.showSpinnerImage(), clearTimeout(this.__to__), this.isImaging = !0, this.__to__ = setTimeout(async () => {
        try {
          const { default: t } = await import("./img-DGzWcJ4Y.js");
          await t({
            domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
            fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy",
            format: "png"
          });
        } catch (t) {
          console.error("Error generating image:", t);
        } finally {
          this.isImaging = !1;
        }
      }, 100);
    }
  }
}, Xe = ["id"], qe = ["viewBox"], Ze = { key: 0 }, Ue = { class: "vue-ui-xy-grid" }, Je = ["stroke", "x1", "x2", "y1", "y2"], Qe = ["stroke", "x1", "x2", "y1", "y2"], Ke = { key: 1 }, je = ["x1", "x2", "y1", "y2", "stroke"], $e = ["x1", "x2", "y1", "y2", "stroke"], et = ["x1", "x2", "y1", "y2", "stroke"], tt = { key: 3 }, at = ["x1", "x2", "y1", "y2", "stroke"], it = ["id"], rt = ["stop-color"], lt = ["stop-color"], st = ["stop-color"], nt = ["id"], ct = ["stop-color"], ot = ["stop-color"], ht = ["stop-color"], dt = ["id"], ut = ["stop-color"], gt = ["stop-color"], ft = ["id"], Nt = ["stop-color"], mt = ["stop-color"], It = ["id"], xt = ["stop-color"], bt = ["stop-color"], Ft = ["x", "y", "height", "width", "fill"], _t = ["x", "y", "width"], yt = ["x", "y", "height", "width", "fill"], At = ["x", "y", "height", "width", "rx", "fill", "stroke", "stroke-width"], Lt = ["width", "x", "y"], Ct = { key: 0 }, St = ["id"], kt = ["fill"], wt = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], Ot = ["x", "y", "font-size", "fill"], Gt = ["stroke", "x1", "x2", "y1", "y2"], vt = { key: 2 }, pt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], zt = ["x", "y", "width", "height", "stroke", "stroke-width", "stroke-linecap", "stroke-linejoin", "stroke-dasharray"], Mt = { key: 4 }, Pt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Tt = ["fill", "font-size", "transform"], Vt = ["x1", "x2", "y1", "y2", "stroke"], Rt = ["x", "y", "font-size", "fill"], Dt = ["x1", "x2", "y1", "y2", "stroke"], Wt = ["x", "y", "font-size", "fill"], Ht = ["width", "x", "y"], Et = { style: { width: "100%" } }, Bt = { key: 0 }, Yt = ["id"], Xt = ["fill"], qt = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], Zt = ["x", "y", "font-size", "fill"], Ut = ["d", "stroke", "stroke-width", "stroke-dasharray"], Jt = { key: 1 }, Qt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], Kt = { key: 0 }, jt = ["d", "fill"], $t = ["d", "fill"], ea = ["d", "stroke", "stroke-width", "stroke-dasharray"], ta = { key: 2 }, aa = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], ia = ["width", "x", "y"], ra = { style: { width: "100%" } }, la = { key: 3 }, sa = ["id"], na = ["fill"], ca = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], oa = ["x", "y", "font-size", "fill"], ha = { key: 5 }, da = ["x", "y", "font-size", "fill"], ua = ["x", "y", "font-size", "fill", "font-weight"], ga = { key: 6 }, fa = ["x", "y", "font-size", "fill"], Na = ["x", "y"], ma = ["x", "y"], Ia = { key: 7 }, xa = ["x", "y", "font-size", "fill"], ba = ["x", "y"], Fa = ["x", "y"], _a = ["x", "y", "font-size", "fill", "innerHTML"], ya = ["x", "y", "font-size", "fill", "innerHTML"], Aa = ["x", "y", "font-size", "fill", "innerHTML"], La = ["x", "y", "font-size", "fill", "innerHTML"], Ca = ["x", "y", "width", "height", "fill", "onMouseenter"], Sa = ["font-size", "fill", "transform"], ka = ["x", "y", "font-size", "fill"], wa = { key: 9 }, Oa = ["text-anchor", "font-size", "fill", "transform"], Ga = ["x", "y", "height", "width", "onMouseenter", "onClick"], va = { key: 10 }, pa = ["x", "y"], za = ["cx", "cy", "r", "fill"], Ma = {
  key: 3,
  class: "vue-data-ui-watermark"
}, Pa = ["onClick"], Ta = {
  key: 0,
  viewBox: "0 0 20 12",
  height: "14",
  width: "20"
}, Va = ["fill"], Ra = {
  key: 1,
  viewBox: "0 0 12 12",
  height: "14",
  width: "14"
}, Da = ["fill"], Wa = {
  key: 7,
  ref: "chartLegend"
}, Ha = {
  style: { display: "flex", "flex-direction": "row", gap: "6px", "align-items": "center", "padding-left": "6px" },
  "data-html2canvas-ignore": ""
}, Ea = ["innerHTML"];
function Ba(t, s, o, N, i, e) {
  const x = V("Title"), _ = V("UserOptions"), k = V("PackageVersion"), f = V("Shape"), L = V("Skeleton"), M = V("Slicer"), w = V("Tooltip"), p = V("BaseIcon"), v = V("TableSparkline"), F = V("DataTable"), C = V("Accordion");
  return r(), l("div", {
    id: `vue-ui-xy_${i.uniqueId}`,
    class: P(`vue-ui-xy ${i.isFullscreen ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.FINAL_CONFIG.useCssAnimation ? "" : "vue-ui-dna"}`),
    ref: "chart",
    style: A(`background:${e.FINAL_CONFIG.chart.backgroundColor}; color:${e.FINAL_CONFIG.chart.color};width:100%;${e.FINAL_CONFIG.chart.title.text ? "" : "padding-top:36px"};font-family:${e.FINAL_CONFIG.chart.fontFamily};${e.FINAL_CONFIG.responsive ? "height: 100%" : ""}`)
  }, [
    e.FINAL_CONFIG.chart.title.show ? (r(), l("div", {
      key: 0,
      ref: "chartTitle",
      class: "vue-ui-xy-title",
      style: A(`font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      (r(), R(x, {
        key: `title_${i.titleStep}`,
        config: {
          title: {
            cy: "xy-div-title",
            ...e.FINAL_CONFIG.chart.title
          },
          subtitle: {
            cy: "xy-div-subtitle",
            ...e.FINAL_CONFIG.chart.title.subtitle
          }
        }
      }, null, 8, ["config"]))
    ], 4)) : h("", !0),
    e.FINAL_CONFIG.chart.userOptions.show && e.isDataset ? (r(), R(_, {
      ref: "defails",
      key: `user_options_${i.step}`,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      isPrinting: i.isPrinting,
      isImaging: i.isImaging,
      uid: i.uniqueId,
      hasTooltip: e.FINAL_CONFIG.chart.userOptions.buttons.tooltip && e.FINAL_CONFIG.chart.tooltip.show,
      hasPdf: e.FINAL_CONFIG.chart.userOptions.buttons.pdf,
      hasXls: e.FINAL_CONFIG.chart.userOptions.buttons.csv,
      hasImg: e.FINAL_CONFIG.chart.userOptions.buttons.img,
      hasLabel: e.FINAL_CONFIG.chart.userOptions.buttons.labels,
      hasTable: e.FINAL_CONFIG.chart.userOptions.buttons.table,
      hasStack: o.dataset.length > 1 && e.FINAL_CONFIG.chart.userOptions.buttons.stack,
      hasFullscreen: e.FINAL_CONFIG.chart.userOptions.buttons.fullscreen,
      isStacked: i.mutableConfig.isStacked,
      isFullscreen: i.isFullscreen,
      chartElement: t.$refs.chart,
      position: e.FINAL_CONFIG.chart.userOptions.position,
      isTooltip: i.mutableConfig.showTooltip,
      titles: { ...e.FINAL_CONFIG.chart.userOptions.buttonTitles },
      onToggleFullscreen: e.toggleFullscreen,
      onGeneratePdf: e.generatePdf,
      onGenerateCsv: e.generateCsv,
      onGenerateImage: e.generateImage,
      onToggleTable: e.toggleTable,
      onToggleLabels: e.toggleLabels,
      onToggleStack: e.toggleStack,
      onToggleTooltip: e.toggleTooltip
    }, Re({ _: 2 }, [
      t.$slots.optionTooltip ? {
        name: "optionTooltip",
        fn: z(() => [
          G(t.$slots, "optionTooltip", {}, void 0, !0)
        ]),
        key: "0"
      } : void 0,
      t.$slots.optionPdf ? {
        name: "optionPdf",
        fn: z(() => [
          G(t.$slots, "optionPdf", {}, void 0, !0)
        ]),
        key: "1"
      } : void 0,
      t.$slots.optionCsv ? {
        name: "optionCsv",
        fn: z(() => [
          G(t.$slots, "optionCsv", {}, void 0, !0)
        ]),
        key: "2"
      } : void 0,
      t.$slots.optionImg ? {
        name: "optionImg",
        fn: z(() => [
          G(t.$slots, "optionImg", {}, void 0, !0)
        ]),
        key: "3"
      } : void 0,
      t.$slots.optionTable ? {
        name: "optionTable",
        fn: z(() => [
          G(t.$slots, "optionTable", {}, void 0, !0)
        ]),
        key: "4"
      } : void 0,
      t.$slots.optionLabels ? {
        name: "optionLabels",
        fn: z(() => [
          G(t.$slots, "optionLabels", {}, void 0, !0)
        ]),
        key: "5"
      } : void 0,
      t.$slots.optionStack ? {
        name: "optionStack",
        fn: z(() => [
          G(t.$slots, "optionStack", {}, void 0, !0)
        ]),
        key: "6"
      } : void 0,
      t.$slots.optionFullscreen ? {
        name: "optionFullscreen",
        fn: z(({ toggleFullscreen: a, isFullscreen: c }) => [
          G(t.$slots, "optionFullscreen", B(Y({ toggleFullscreen: a, isFullscreen: c })), void 0, !0)
        ]),
        key: "7"
      } : void 0
    ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasLabel", "hasTable", "hasStack", "hasFullscreen", "isStacked", "isFullscreen", "chartElement", "position", "isTooltip", "titles", "onToggleFullscreen", "onGeneratePdf", "onGenerateCsv", "onGenerateImage", "onToggleTable", "onToggleLabels", "onToggleStack", "onToggleTooltip"])) : h("", !0),
    e.isDataset ? (r(), l("svg", {
      key: 2,
      xmlns: "http://www.w3.org/2000/svg",
      class: P([{ "vue-data-ui-fullscreen--on": i.isFullscreen, "vue-data-ui-fulscreen--off": !i.isFullscreen }, "vue-ui-xy-svg"]),
      width: "100%",
      viewBox: i.viewBox,
      style: A(`background: transparent; color:${e.FINAL_CONFIG.chart.color}; font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      X(k),
      e.maxSeries > 0 ? (r(), l("g", Ze, [
        u("g", Ue, [
          e.FINAL_CONFIG.chart.grid.labels.xAxis.showBaseline ? (r(), l("line", {
            key: 0,
            stroke: e.FINAL_CONFIG.chart.grid.stroke,
            "stroke-width": "1",
            x1: e.drawingArea.left + e.xPadding,
            x2: e.drawingArea.right - e.xPadding,
            y1: e.drawingArea.bottom,
            y2: e.drawingArea.bottom,
            "stroke-linecap": "round"
          }, null, 8, Je)) : h("", !0),
          i.mutableConfig.useIndividualScale ? e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (r(!0), l(m, { key: 2 }, I(e.allScales, (a) => (r(), l("g", null, [
            a.id === i.selectedScale && a.yLabels.length ? (r(!0), l(m, { key: 0 }, I(a.yLabels, (c) => (r(), l("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.checkNaN(c.y),
              y2: e.checkNaN(c.y),
              stroke: a.color,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, $e))), 256)) : a.yLabels.length ? (r(!0), l(m, { key: 1 }, I(a.yLabels, (c) => (r(), l("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.checkNaN(c.y),
              y2: e.checkNaN(c.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, et))), 256)) : h("", !0)
          ]))), 256)) : h("", !0) : (r(), l(m, { key: 1 }, [
            e.FINAL_CONFIG.chart.grid.labels.yAxis.showBaseline ? (r(), l("line", {
              key: 0,
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left + e.xPadding,
              y1: e.drawingArea.top,
              y2: e.drawingArea.bottom,
              "stroke-linecap": "round"
            }, null, 8, Qe)) : h("", !0),
            e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (r(), l("g", Ke, [
              (r(!0), l(m, null, I(e.yLabels, (a) => (r(), l("line", {
                x1: e.drawingArea.left + e.xPadding,
                x2: e.drawingArea.right - e.xPadding,
                y1: e.checkNaN(a.y),
                y2: e.checkNaN(a.y),
                stroke: e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-width": 0.5,
                "stroke-linecap": "round"
              }, null, 8, je))), 256))
            ])) : h("", !0)
          ], 64)),
          e.FINAL_CONFIG.chart.grid.showVerticalLines ? (r(), l("g", tt, [
            (r(!0), l(m, null, I(e.maxSeries + (e.FINAL_CONFIG.chart.grid.position === "middle" ? 1 : 0), (a, c) => (r(), l("line", {
              key: `grid_vertical_line_${c}`,
              x1: e.drawingArea.width / e.maxSeries * c + e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.width / e.maxSeries * c + e.drawingArea.left + e.xPadding,
              y1: e.drawingArea.top,
              y2: e.drawingArea.bottom,
              "stroke-width": "0.5",
              stroke: e.FINAL_CONFIG.chart.grid.stroke
            }, null, 8, at))), 128))
          ])) : h("", !0)
        ]),
        (r(!0), l(m, null, I(e.barSet, (a, c) => (r(), l("defs", {
          key: `def_rect_${c}`
        }, [
          u("linearGradient", {
            id: `rectGradient_pos_${c}_${i.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": a.color
            }, null, 8, rt),
            u("stop", {
              offset: "62%",
              "stop-color": `${e.shiftHue(a.color, 0.02)}`
            }, null, 8, lt),
            u("stop", {
              offset: "100%",
              "stop-color": `${e.shiftHue(a.color, 0.05)}`
            }, null, 8, st)
          ], 8, it),
          u("linearGradient", {
            id: `rectGradient_neg_${c}_${i.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(a.color, 0.05)}`
            }, null, 8, ct),
            u("stop", {
              offset: "38%",
              "stop-color": `${e.shiftHue(a.color, 0.02)}`
            }, null, 8, ot),
            u("stop", {
              offset: "100%",
              "stop-color": a.color
            }, null, 8, ht)
          ], 8, nt)
        ]))), 128)),
        (r(!0), l(m, null, I(e.plotSet, (a, c) => (r(), l("defs", {
          key: `def_plot_${c}`
        }, [
          u("radialGradient", {
            id: `plotGradient_${c}_${i.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(a.color, 0.05)}`
            }, null, 8, ut),
            u("stop", {
              offset: "100%",
              "stop-color": a.color
            }, null, 8, gt)
          ], 8, dt)
        ]))), 128)),
        (r(!0), l(m, null, I(e.lineSet, (a, c) => (r(), l("defs", {
          key: `def_line_${c}`
        }, [
          u("radialGradient", {
            id: `lineGradient_${c}_${i.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(a.color, 0.05)}`
            }, null, 8, Nt),
            u("stop", {
              offset: "100%",
              "stop-color": a.color
            }, null, 8, mt)
          ], 8, ft),
          u("linearGradient", {
            id: `areaGradient_${c}_${i.uniqueId}`,
            x1: "0%",
            x2: "100%",
            y1: "0%",
            y2: "0%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.setOpacity(e.shiftHue(a.color, 0.03), e.FINAL_CONFIG.line.area.opacity)}`
            }, null, 8, xt),
            u("stop", {
              offset: "100%",
              "stop-color": `${e.setOpacity(a.color, e.FINAL_CONFIG.line.area.opacity)}`
            }, null, 8, bt)
          ], 8, It)
        ]))), 128)),
        (r(!0), l(m, null, I(e.highlightAreas, (a) => (r(), l("g", null, [
          a.show ? (r(!0), l(m, { key: 0 }, I(a.span, (c, n) => (r(), l("g", null, [
            u("rect", {
              style: A({
                transition: "none",
                opacity: a.from + n >= i.slicer.start && a.from + n <= i.slicer.end - 1 ? 1 : 0
              }),
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (a.from + n - i.slicer.start),
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: e.setOpacity(a.color, a.opacity)
            }, null, 12, Ft),
            a.caption.text && n === 0 ? (r(), l("foreignObject", {
              key: 0,
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (a.from + n - i.slicer.start) - (a.caption.width === "auto" ? 0 : a.caption.width / 2 - e.drawingArea.width / e.maxSeries * a.span / 2),
              y: e.drawingArea.top + a.caption.offsetY,
              style: A({
                overflow: "visible",
                opacity: a.to >= i.slicer.start && a.from < i.slicer.end ? 1 : 0
              }),
              height: "1",
              width: a.caption.width === "auto" ? e.drawingArea.width / e.maxSeries * a.span : a.caption.width
            }, [
              u("div", {
                style: A(`padding:${a.caption.padding}px;text-align:${a.caption.textAlign};font-size:${a.caption.fontSize}px;color:${a.caption.color};font-weight:${a.caption.bold ? "bold" : "normal"}`)
              }, S(a.caption.text), 5)
            ], 12, _t)) : h("", !0)
          ]))), 256)) : h("", !0)
        ]))), 256)),
        u("g", null, [
          (r(!0), l(m, null, I(e.maxSeries, (a, c) => (r(), l("g", {
            key: `tooltip_trap_${c}`
          }, [
            u("rect", {
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * c,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: [i.selectedMinimapIndex, i.selectedSerieIndex, i.selectedRowIndex].includes(c) ? e.setOpacity(e.FINAL_CONFIG.chart.highlighter.color, e.FINAL_CONFIG.chart.highlighter.opacity) : "transparent"
            }, null, 8, yt)
          ]))), 128))
        ]),
        e.barSet.length ? (r(!0), l(m, { key: 0 }, I(e.barSet, (a, c) => (r(), l("g", {
          key: `serie_bar_${c}`,
          class: P(`serie_bar_${c}`),
          style: A(`opacity:${i.selectedScale ? i.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (r(!0), l(m, null, I(a.plots, (n, g) => (r(), l("g", {
            key: `bar_plot_${c}_${g}`
          }, [
            e.canShowValue(n.value) ? (r(), l("rect", {
              key: 0,
              x: e.calcRectX(n),
              y: i.mutableConfig.useIndividualScale ? e.calcIndividualRectY(n) : e.calcRectY(n),
              height: i.mutableConfig.useIndividualScale ? Math.abs(e.calcIndividualHeight(n)) : Math.abs(e.calcRectHeight(n)),
              width: e.calcRectWidth() - (i.mutableConfig.useIndividualScale && i.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (i.mutableConfig.useIndividualScale && i.mutableConfig.isStacked ? 0 : e.barPeriodGap),
              rx: e.FINAL_CONFIG.bar.borderRadius,
              fill: e.FINAL_CONFIG.bar.useGradient ? n.value >= 0 ? `url(#rectGradient_pos_${c}_${i.uniqueId})` : `url(#rectGradient_neg_${c}_${i.uniqueId})` : a.color,
              stroke: e.FINAL_CONFIG.bar.border.useSerieColor ? a.color : e.FINAL_CONFIG.bar.border.stroke,
              "stroke-width": e.FINAL_CONFIG.bar.border.strokeWidth
            }, null, 8, At)) : h("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (r(), l("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: (e.calcRectWidth() - (i.mutableConfig.useIndividualScale && i.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (i.mutableConfig.useIndividualScale && i.mutableConfig.isStacked ? 0 : e.barPeriodGap) / 2) + e.FINAL_CONFIG.chart.comments.width,
              x: e.calcRectX(n) - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: e.checkNaN(n.y) + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              G(t.$slots, "plot-comment", {
                plot: { ...n, color: a.color }
              }, void 0, !0)
            ], 8, Lt)) : h("", !0)
          ]))), 128)),
          Object.hasOwn(a, "useProgression") && a.useProgression === !0 && !isNaN(e.calcLinearProgression(a.plots).trend) ? (r(), l("g", Ct, [
            u("defs", null, [
              u("marker", {
                id: `bar_arrow_${c}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                u("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: a.color
                }, null, 8, kt)
              ], 8, St)
            ]),
            a.plots.length > 1 ? (r(), l("line", {
              key: 0,
              x1: e.calcLinearProgression(a.plots).x1,
              x2: e.calcLinearProgression(a.plots).x2,
              y1: e.calcLinearProgression(a.plots).y1,
              y2: e.calcLinearProgression(a.plots).y2,
              "stroke-width": 1,
              stroke: a.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#bar_arrow_${c})`
            }, null, 8, wt)) : h("", !0),
            a.plots.length > 1 ? (r(), l("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(a.plots).x2,
              y: e.calcLinearProgression(a.plots).y2 - 6,
              "font-size": i.fontSizes.plotLabels,
              fill: a.color
            }, S(e.dataLabel({
              v: e.calcLinearProgression(a.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, Ot)) : h("", !0)
          ])) : h("", !0)
        ], 6))), 128)) : h("", !0),
        !i.mutableConfig.useIndividualScale && e.FINAL_CONFIG.chart.grid.labels.zeroLine.show ? (r(), l("line", {
          key: 1,
          stroke: e.FINAL_CONFIG.chart.grid.stroke,
          "stroke-width": "1",
          x1: e.drawingArea.left + e.xPadding,
          x2: e.drawingArea.right - e.xPadding,
          y1: e.checkNaN(e.zero),
          y2: e.checkNaN(e.zero),
          "stroke-linecap": "round"
        }, null, 8, Gt)) : h("", !0),
        e.FINAL_CONFIG.chart.highlighter.useLine && (![null, void 0].includes(i.selectedSerieIndex) || i.selectedMinimapIndex !== null) ? (r(), l("g", vt, [
          u("line", {
            x1: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (i.selectedSerieIndex || i.selectedMinimapIndex) + e.drawingArea.width / e.maxSeries / 2,
            x2: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (i.selectedSerieIndex || i.selectedMinimapIndex) + e.drawingArea.width / e.maxSeries / 2,
            y1: e.drawingArea.top,
            y2: e.drawingArea.bottom,
            stroke: e.FINAL_CONFIG.chart.highlighter.color,
            "stroke-width": e.FINAL_CONFIG.chart.highlighter.lineWidth,
            "stroke-dasharray": e.FINAL_CONFIG.chart.highlighter.lineDasharray,
            "stroke-linecap": "round",
            style: { transition: "none !important", animation: "none !important", "pointer-events": "none" }
          }, null, 8, pt)
        ])) : h("", !0),
        e.FINAL_CONFIG.chart.grid.frame.show ? (r(), l("rect", {
          key: 3,
          style: { pointerEvents: "none", transition: "none" },
          x: e.drawingArea.left + e.xPadding < 0 ? 0 : e.drawingArea.left + e.xPadding,
          y: e.drawingArea.top,
          width: e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries) < 0 ? 0 : e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries),
          height: e.drawingArea.height < 0 ? 0 : e.drawingArea.height,
          fill: "transparent",
          stroke: e.FINAL_CONFIG.chart.grid.frame.stroke,
          "stroke-width": e.FINAL_CONFIG.chart.grid.frame.strokeWidth,
          "stroke-linecap": e.FINAL_CONFIG.chart.grid.frame.strokeLinecap,
          "stroke-linejoin": e.FINAL_CONFIG.chart.grid.frame.strokeLinejoin,
          "stroke-dasharray": e.FINAL_CONFIG.chart.grid.frame.strokeDasharray
        }, null, 8, zt)) : h("", !0),
        e.FINAL_CONFIG.chart.grid.labels.show ? (r(), l("g", Mt, [
          i.mutableConfig.useIndividualScale ? (r(), l(m, { key: 0 }, [
            (r(!0), l(m, null, I(e.allScales, (a) => (r(), l("g", null, [
              u("line", {
                x1: a.x + e.xPadding,
                x2: a.x + e.xPadding,
                y1: i.mutableConfig.isStacked ? e.checkNaN(e.drawingArea.bottom - a.yOffset - a.individualHeight) : e.checkNaN(e.drawingArea.top),
                y2: i.mutableConfig.isStacked ? e.checkNaN(e.drawingArea.bottom - a.yOffset) : e.checkNaN(e.drawingArea.bottom),
                stroke: a.color,
                "stroke-width": e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-linecap": "round",
                style: A(`opacity:${i.selectedScale ? i.selectedScale === a.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
              }, null, 12, Pt)
            ]))), 256)),
            (r(!0), l(m, null, I(e.allScales, (a) => (r(), l("g", {
              style: A(`opacity:${i.selectedScale ? i.selectedScale === a.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
            }, [
              u("text", {
                fill: a.color,
                "font-size": i.fontSizes.dataLabels,
                "text-anchor": "middle",
                transform: `translate(${a.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth + 5}, ${i.mutableConfig.isStacked ? e.drawingArea.bottom - a.yOffset - a.individualHeight / 2 : e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`
              }, S(a.name) + " " + S(a.scaleLabel ? `- ${a.scaleLabel}` : ""), 9, Tt),
              (r(!0), l(m, null, I(a.yLabels, (c, n) => (r(), l("line", {
                x1: a.x - 3 + e.xPadding,
                x2: a.x + e.xPadding,
                y1: e.checkNaN(c.y),
                y2: e.checkNaN(c.y),
                stroke: a.color,
                "stroke-width": 1,
                "stroke-linecap": "round"
              }, null, 8, Vt))), 256)),
              (r(!0), l(m, null, I(a.yLabels, (c, n) => (r(), l("text", {
                x: a.x - 5 + e.xPadding,
                y: e.checkNaN(c.y) + i.fontSizes.dataLabels / 3,
                "font-size": i.fontSizes.dataLabels,
                "text-anchor": "end",
                fill: a.color
              }, S(e.applyDataLabel(
                e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
                c.value,
                e.dataLabel({
                  p: c.prefix,
                  v: c.value,
                  s: c.suffix,
                  r: 1
                }),
                { datapoint: c.datapoint, seriesIndex: n }
              )), 9, Rt))), 256))
            ], 4))), 256))
          ], 64)) : (r(!0), l(m, { key: 1 }, I(e.yLabels, (a, c) => (r(), l("g", {
            key: `yLabel_${c}`
          }, [
            e.canShowValue(a) && a.value >= e.niceScale.min && a.value <= e.niceScale.max ? (r(), l("line", {
              key: 0,
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left - 5 + e.xPadding,
              y1: e.checkNaN(a.y),
              y2: e.checkNaN(a.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              "stroke-linecap": "round"
            }, null, 8, Dt)) : h("", !0),
            a.value >= e.niceScale.min && a.value <= e.niceScale.max ? (r(), l("text", {
              key: 1,
              x: e.drawingArea.left - 7 + e.xPadding,
              y: e.checkNaN(a.y + i.fontSizes.dataLabels / 3),
              "font-size": i.fontSizes.dataLabels,
              "text-anchor": "end",
              fill: e.FINAL_CONFIG.chart.grid.labels.color
            }, S(e.canShowValue(a.value) ? e.applyDataLabel(
              e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
              a.value,
              e.dataLabel({
                p: a.prefix,
                v: a.value,
                s: a.suffix,
                r: 1
              })
            ) : ""), 9, Wt)) : h("", !0)
          ]))), 128))
        ])) : h("", !0),
        (r(!0), l(m, null, I(e.plotSet, (a, c) => (r(), l("g", {
          key: `serie_plot_${c}`,
          class: P(`serie_plot_${c}`),
          style: A(`opacity:${i.selectedScale ? i.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (r(!0), l(m, null, I(a.plots, (n, g) => (r(), l("g", {
            key: `circle_plot_${c}_${g}`
          }, [
            n && e.canShowValue(n.value) ? (r(), R(f, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(a.shape) ? a.shape : "circle",
              color: e.FINAL_CONFIG.plot.useGradient ? `url(#plotGradient_${c}_${i.uniqueId})` : e.FINAL_CONFIG.plot.dot.useSerieColor ? a.color : e.FINAL_CONFIG.plot.dot.fill,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: i.selectedSerieIndex !== null && i.selectedSerieIndex === g || i.selectedMinimapIndex !== null && i.selectedMinimapIndex === g ? (i.plotRadii.plot || 6) * 1.5 : i.plotRadii.plot || 6,
              stroke: e.FINAL_CONFIG.plot.dot.useSerieColor ? e.FINAL_CONFIG.chart.backgroundColor : a.color,
              strokeWidth: e.FINAL_CONFIG.plot.dot.strokeWidth
            }, null, 8, ["shape", "color", "plot", "radius", "stroke", "strokeWidth"])) : h("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (r(), l("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              u("div", Et, [
                G(t.$slots, "plot-comment", {
                  plot: { ...n, color: a.color }
                }, void 0, !0)
              ])
            ], 8, Ht)) : h("", !0)
          ]))), 128)),
          Object.hasOwn(a, "useProgression") && a.useProgression === !0 && !isNaN(e.calcLinearProgression(a.plots).trend) ? (r(), l("g", Bt, [
            u("defs", null, [
              u("marker", {
                id: `plot_arrow_${c}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                u("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: a.color
                }, null, 8, Xt)
              ], 8, Yt)
            ]),
            a.plots.length > 1 ? (r(), l("line", {
              key: 0,
              x1: e.calcLinearProgression(a.plots).x1,
              x2: e.calcLinearProgression(a.plots).x2,
              y1: e.calcLinearProgression(a.plots).y1,
              y2: e.calcLinearProgression(a.plots).y2,
              "stroke-width": 1,
              stroke: a.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#plot_arrow_${c})`
            }, null, 8, qt)) : h("", !0),
            a.plots.length > 1 ? (r(), l("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(a.plots).x2,
              y: e.calcLinearProgression(a.plots).y2 - 6,
              "font-size": i.fontSizes.plotLabels,
              fill: a.color
            }, S(e.dataLabel({
              v: e.calcLinearProgression(a.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, Zt)) : h("", !0)
          ])) : h("", !0)
        ], 6))), 128)),
        (r(!0), l(m, null, I(e.lineSet, (a, c) => (r(), l("g", {
          key: `serie_line_${c}`,
          class: P(`serie_line_${c}`),
          style: A(`opacity:${i.selectedScale ? i.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          a.smooth && a.plots.length > 1 ? (r(), l("path", {
            key: 0,
            d: `M${a.curve}`,
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
            "stroke-dasharray": a.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, Ut)) : a.plots.length > 1 ? (r(), l("g", Jt, [
            (r(!0), l(m, null, I(a.plots, (n, g) => (r(), l("g", {
              key: `line_${c}_${g}`
            }, [
              n && g < a.plots.length - 1 && a.plots[g + 1] && e.canShowValue(n.value) && e.canShowValue(a.plots[g + 1].value) ? (r(), l("line", {
                key: 0,
                x1: n.x,
                x2: a.plots[g + 1].x,
                y1: n.y,
                y2: a.plots[g + 1].y,
                stroke: e.FINAL_CONFIG.chart.backgroundColor,
                "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
                "stroke-dasharray": a.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
                "stroke-linejoin": "round",
                "stroke-linecap": "round"
              }, null, 8, Qt)) : h("", !0)
            ]))), 128))
          ])) : h("", !0)
        ], 6))), 128)),
        (r(!0), l(m, null, I(e.lineSet, (a, c) => (r(), l("g", {
          key: `serie_line_${c}`,
          class: P(`serie_line_${c}`),
          style: A(`opacity:${i.selectedScale ? i.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          a.useArea && a.plots.length > 1 ? (r(), l("g", Kt, [
            a.smooth ? (r(), l("path", {
              key: 0,
              d: `M ${a.plots[0] ? a.plots[0].x : Math.min(...a.plots.filter((n) => !!n).map((n) => n.x))},${i.mutableConfig.isStacked ? e.drawingArea.bottom - a.yOffset : e.drawingArea.bottom} ${a.curve} L ${a.plots.at(-1) ? a.plots.at(-1).x : e.drawingArea.left + e.slot.line * c + e.slot.line / 2},${i.mutableConfig.isStacked ? e.drawingArea.bottom - a.yOffset : e.drawingArea.bottom} Z`,
              fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${c}_${i.uniqueId})` : e.setOpacity(a.color, e.FINAL_CONFIG.line.area.opacity)
            }, null, 8, jt)) : (r(), l("path", {
              key: 1,
              d: `M${a.area}Z`,
              fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${c}_${i.uniqueId})` : e.setOpacity(a.color, e.FINAL_CONFIG.line.area.opacity)
            }, null, 8, $t))
          ])) : h("", !0),
          a.smooth && a.plots.length > 1 ? (r(), l("path", {
            key: 1,
            d: `M${a.curve}`,
            stroke: a.color,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
            "stroke-dasharray": a.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, ea)) : a.plots.length > 1 ? (r(), l("g", ta, [
            (r(!0), l(m, null, I(a.plots, (n, g) => (r(), l("g", {
              key: `line_${c}_${g}`
            }, [
              n && g < a.plots.length - 1 && a.plots[g + 1] && e.canShowValue(n.value) && e.canShowValue(a.plots[g + 1].value) ? (r(), l("line", {
                key: 0,
                x1: n.x,
                x2: a.plots[g + 1].x,
                y1: n.y,
                y2: a.plots[g + 1].y,
                stroke: a.color,
                "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
                "stroke-dasharray": a.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
                "stroke-linejoin": "round",
                "stroke-linecap": "round"
              }, null, 8, aa)) : h("", !0)
            ]))), 128))
          ])) : h("", !0),
          (r(!0), l(m, null, I(a.plots, (n, g) => (r(), l("g", {
            key: `circle_line_${c}_${g}`
          }, [
            n && e.canShowValue(n.value) ? (r(), R(f, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(a.shape) ? a.shape : "circle",
              color: e.FINAL_CONFIG.line.useGradient ? `url(#lineGradient_${c}_${i.uniqueId})` : e.FINAL_CONFIG.line.dot.useSerieColor ? a.color : e.FINAL_CONFIG.line.dot.fill,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: i.selectedSerieIndex !== null && i.selectedSerieIndex === g || i.selectedMinimapIndex !== null && i.selectedMinimapIndex === g ? (i.plotRadii.line || 6) * 1.5 : i.plotRadii.line || 6,
              stroke: e.FINAL_CONFIG.line.dot.useSerieColor ? e.FINAL_CONFIG.chart.backgroundColor : a.color,
              strokeWidth: e.FINAL_CONFIG.line.dot.strokeWidth
            }, null, 8, ["shape", "color", "plot", "radius", "stroke", "strokeWidth"])) : h("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (r(), l("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              u("div", ra, [
                G(t.$slots, "plot-comment", {
                  plot: { ...n, color: a.color }
                }, void 0, !0)
              ])
            ], 8, ia)) : h("", !0)
          ]))), 128)),
          Object.hasOwn(a, "useProgression") && a.useProgression === !0 && !isNaN(e.calcLinearProgression(a.plots).trend) ? (r(), l("g", la, [
            u("defs", null, [
              u("marker", {
                id: `line_arrow_${c}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                u("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: a.color
                }, null, 8, na)
              ], 8, sa)
            ]),
            a.plots.length > 1 ? (r(), l("line", {
              key: 0,
              x1: e.calcLinearProgression(a.plots).x1,
              x2: e.calcLinearProgression(a.plots).x2,
              y1: e.calcLinearProgression(a.plots).y1,
              y2: e.calcLinearProgression(a.plots).y2,
              "stroke-width": 1,
              stroke: a.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#line_arrow_${c})`
            }, null, 8, ca)) : h("", !0),
            a.plots.length > 1 ? (r(), l("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(a.plots).x2,
              y: e.calcLinearProgression(a.plots).y2 - 6,
              "font-size": i.fontSizes.plotLabels,
              fill: a.color
            }, S(e.dataLabel({
              v: e.calcLinearProgression(a.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, oa)) : h("", !0)
          ])) : h("", !0)
        ], 6))), 128)),
        (e.FINAL_CONFIG.bar.labels.show || e.FINAL_CONFIG.bar.serieName.show) && i.mutableConfig.dataLabels.show ? (r(), l("g", ha, [
          (r(!0), l(m, null, I(e.barSet, (a, c) => (r(), l("g", {
            key: `xLabel_bar_${c}`,
            class: P(`xLabel_bar_${c}`),
            style: A(`opacity:${i.selectedScale ? i.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (r(!0), l(m, null, I(a.plots, (n, g) => (r(), l("g", {
              key: `xLabel_bar_${c}_${g}`
            }, [
              n && (!Object.hasOwn(a, "dataLabels") || a.dataLabels === !0) && e.FINAL_CONFIG.bar.labels.show ? (r(), l("text", {
                key: 0,
                x: i.mutableConfig.useIndividualScale && i.mutableConfig.isStacked ? n.x + e.slot.line / 2 : e.calcRectX(n) + e.calcRectWidth() / 2 - e.barPeriodGap / 2,
                y: e.checkNaN(n.y) + (n.value > 0 ? e.FINAL_CONFIG.bar.labels.offsetY : -e.FINAL_CONFIG.bar.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": i.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.labels.color
              }, S(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.bar.labels.formatter,
                n.value,
                e.dataLabel({
                  p: a.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: a.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.bar.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: a
                }
              ) : ""), 9, da)) : h("", !0),
              n && e.FINAL_CONFIG.bar.serieName.show ? (r(), l("text", {
                key: 1,
                x: i.mutableConfig.useIndividualScale && i.mutableConfig.isStacked ? n.x + e.slot.line / 2 : n.x + e.calcRectWidth() * 1.1,
                y: n.y + (n.value > 0 ? e.FINAL_CONFIG.bar.serieName.offsetY : -e.FINAL_CONFIG.bar.serieName.offsetY * 3),
                "text-anchor": "middle",
                "font-size": i.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.serieName.useSerieColor ? a.color : e.FINAL_CONFIG.bar.serieName.color,
                "font-weight": e.FINAL_CONFIG.bar.serieName.bold ? "bold" : "normal"
              }, S(e.FINAL_CONFIG.bar.serieName.useAbbreviation ? e.abbreviate({ source: a.name, length: e.FINAL_CONFIG.bar.serieName.abbreviationSize }) : a.name), 9, ua)) : h("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : h("", !0),
        e.FINAL_CONFIG.plot.labels.show && i.mutableConfig.dataLabels.show ? (r(), l("g", ga, [
          (r(!0), l(m, null, I(e.plotSet, (a, c) => (r(), l("g", {
            key: `xLabel_plot_${c}`,
            class: P(`xLabel_plot_${c}`),
            style: A(`opacity:${i.selectedScale ? i.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (r(!0), l(m, null, I(a.plots, (n, g) => (r(), l("g", {
              key: `xLabel_plot_${c}_${g}`
            }, [
              n && !Object.hasOwn(a, "dataLabels") || a.dataLabels === !0 ? (r(), l("text", {
                key: 0,
                x: n.x,
                y: n.y + e.FINAL_CONFIG.plot.labels.offsetY,
                "text-anchor": "middle",
                "font-size": i.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.plot.labels.color
              }, S(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.plot.labels.formatter,
                n.value,
                e.dataLabel({
                  p: a.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: a.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.plot.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: a
                }
              ) : ""), 9, fa)) : h("", !0),
              n && g === 0 && a.useTag && a.useTag === "start" ? (r(), l("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: A(`padding: 3px; background:${e.setOpacity(a.color, 80)};color:${e.adaptColorToBackground(a.color)};width:fit-content;font-size:${i.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(a.name), 5)
              ], 8, Na)) : h("", !0),
              n && g === a.plots.length - 1 && a.useTag && a.useTag === "end" ? (r(), l("foreignObject", {
                key: 2,
                x: n.x - a.name.length * (i.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: A(`padding: 3px; background:${e.setOpacity(a.color, 80)};color:${e.adaptColorToBackground(a.color)};width:fit-content;font-size:${i.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(a.name), 5)
              ], 8, ma)) : h("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : h("", !0),
        e.FINAL_CONFIG.line.labels.show && i.mutableConfig.dataLabels.show ? (r(), l("g", Ia, [
          (r(!0), l(m, null, I(e.lineSet, (a, c) => (r(), l("g", {
            key: `xLabel_line_${c}`,
            class: P(`xLabel_line_${c}`),
            style: A(`opacity:${i.selectedScale ? i.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (r(!0), l(m, null, I(a.plots, (n, g) => (r(), l("g", {
              key: `xLabel_line_${c}_${g}`
            }, [
              n && !Object.hasOwn(a, "dataLabels") || a.dataLabels === !0 ? (r(), l("text", {
                key: 0,
                x: n.x,
                y: n.y + (n.value > 0 ? e.FINAL_CONFIG.line.labels.offsetY : -e.FINAL_CONFIG.line.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": i.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.line.labels.color
              }, S(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.line.labels.formatter,
                n.value,
                e.dataLabel({
                  p: a.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: a.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.line.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: a
                }
              ) : ""), 9, xa)) : h("", !0),
              n && g === 0 && a.useTag && a.useTag === "start" ? (r(), l("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: A(`padding: 3px; background:${e.setOpacity(a.color, 80)};color:${e.adaptColorToBackground(a.color)};width:fit-content;font-size:${i.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(a.name), 5)
              ], 8, ba)) : h("", !0),
              n && g === a.plots.length - 1 && a.useTag && a.useTag === "end" ? (r(), l("foreignObject", {
                key: 2,
                x: n.x - a.name.length * (i.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: A(`padding: 3px; background:${e.setOpacity(a.color, 80)};color:${e.adaptColorToBackground(a.color)};width:fit-content;font-size:${i.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(a.name), 5)
              ], 8, Fa)) : h("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : h("", !0),
        (r(!0), l(m, null, I(e.lineSet, (a, c) => (r(), l("g", {
          key: `xLabel_line_${c}`,
          class: P(`xLabel_line_${c}`),
          style: A(`opacity:${i.selectedScale ? i.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (r(!0), l(m, null, I(a.plots, (n, g) => (r(), l("g", {
            key: `xLabel_line_${c}_${g}`
          }, [
            n && g === 0 && a.showSerieName && a.showSerieName === "start" ? (r(), l("text", {
              key: 0,
              x: n.x - i.fontSizes.plotLabels,
              y: n.y,
              "font-size": i.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: a.color,
              innerHTML: e.createTSpans({
                content: a.name,
                fontSize: i.fontSizes.plotLabels,
                fill: a.color,
                x: n.x - i.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, _a)) : h("", !0),
            n && g === a.plots.length - 1 && a.showSerieName && a.showSerieName === "end" ? (r(), l("text", {
              key: 1,
              x: n.x + i.fontSizes.plotLabels,
              y: n.y,
              "font-size": i.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: a.color,
              innerHTML: e.createTSpans({
                content: a.name,
                fontSize: i.fontSizes.plotLabels,
                fill: a.color,
                x: n.x + i.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, ya)) : h("", !0)
          ]))), 128))
        ], 6))), 128)),
        (r(!0), l(m, null, I(e.plotSet, (a, c) => (r(), l("g", {
          key: `xLabel_plot_${c}`,
          class: P(`xLabel_plot_${c}`),
          style: A(`opacity:${i.selectedScale ? i.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (r(!0), l(m, null, I(a.plots, (n, g) => (r(), l("g", {
            key: `xLabel_plot_${c}_${g}`
          }, [
            n && g === 0 && a.showSerieName && a.showSerieName === "start" ? (r(), l("text", {
              key: 0,
              x: n.x - i.fontSizes.plotLabels,
              y: n.y,
              "font-size": i.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: a.color,
              innerHTML: e.createTSpans({
                content: a.name,
                fontSize: i.fontSizes.plotLabels,
                fill: a.color,
                x: n.x - i.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, Aa)) : h("", !0),
            n && g === a.plots.length - 1 && a.showSerieName && a.showSerieName === "end" ? (r(), l("text", {
              key: 1,
              x: n.x + i.fontSizes.plotLabels,
              y: n.y,
              "font-size": i.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: a.color,
              innerHTML: e.createTSpans({
                content: a.name,
                fontSize: i.fontSizes.plotLabels,
                fill: a.color,
                x: n.x + i.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, La)) : h("", !0)
          ]))), 128))
        ], 6))), 128)),
        i.mutableConfig.useIndividualScale && !i.mutableConfig.isStacked ? (r(!0), l(m, { key: 8 }, I(e.allScales, (a) => (r(), l("rect", {
          x: a.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth,
          y: e.drawingArea.top,
          width: e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth,
          height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
          fill: i.selectedScale === a.id ? e.setOpacity(a.color, 20) : "transparent",
          onMouseenter: (c) => i.selectedScale = a.id,
          onMouseleave: s[0] || (s[0] = (c) => i.selectedScale = null)
        }, null, 40, Ca))), 256)) : h("", !0),
        u("g", null, [
          e.FINAL_CONFIG.chart.grid.labels.axis.yLabel && !i.mutableConfig.useIndividualScale ? (r(), l("text", {
            key: 0,
            "font-size": i.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color,
            transform: `translate(${i.fontSizes.yAxis + e.FINAL_CONFIG.chart.grid.labels.axis.yLabelOffsetX}, ${e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`,
            "text-anchor": "middle",
            style: { transition: "none" }
          }, S(e.FINAL_CONFIG.chart.grid.labels.axis.yLabel), 9, Sa)) : h("", !0),
          e.FINAL_CONFIG.chart.grid.labels.axis.xLabel ? (r(), l("text", {
            key: 1,
            "text-anchor": "middle",
            x: i.width / 2,
            y: e.drawingArea.bottom + i.fontSizes.yAxis + i.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.axis.xLabelOffsetY,
            "font-size": i.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color
          }, S(e.FINAL_CONFIG.chart.grid.labels.axis.xLabel), 9, ka)) : h("", !0)
        ]),
        e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.show ? (r(), l("g", wa, [
          (r(!0), l(m, null, I(e.timeLabels, (a, c) => (r(), l("g", {
            key: `time_label_${c}`
          }, [
            a && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || a && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && (c === 0 || c === e.timeLabels.length - 1) && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || a && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && i.selectedSerieIndex === c && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || a && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo && c % Math.floor((this.slicer.end - this.slicer.start) / e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.modulo) === 0 ? (r(), l("text", {
              key: 0,
              "text-anchor": e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation > 0 ? "start" : e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation < 0 ? "end" : "middle",
              "font-size": i.fontSizes.xAxis,
              fill: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.color,
              transform: `translate(${e.drawingArea.left + e.drawingArea.width / e.maxSeries * c + e.drawingArea.width / e.maxSeries / 2}, ${e.drawingArea.bottom + i.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset}), rotate(${e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation})`
            }, S(a || ""), 9, Oa)) : h("", !0)
          ]))), 128))
        ])) : h("", !0),
        u("g", null, [
          (r(!0), l(m, null, I(e.maxSeries, (a, c) => (r(), l("g", {
            key: `tooltip_trap_${c}`
          }, [
            u("rect", {
              "data-cy-trap": "",
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * c,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: "transparent",
              onMouseenter: (n) => e.toggleTooltipVisibility(!0, c),
              onMouseleave: s[1] || (s[1] = (n) => e.toggleTooltipVisibility(!1)),
              onClick: (n) => e.selectX(c)
            }, null, 40, Ga)
          ]))), 128))
        ]),
        e.FINAL_CONFIG.chart.timeTag.show && ![null, void 0].includes(i.selectedSerieIndex) ? (r(), l("g", va, [
          (r(), l("foreignObject", {
            x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * i.selectedSerieIndex - 100 + e.drawingArea.width / e.maxSeries / 2,
            y: e.drawingArea.bottom,
            width: "200",
            height: "40",
            style: { overflow: "visible !important" }
          }, [
            u("div", {
              class: "vue-ui-xy-time-tag",
              style: A(`width: fit-content;margin: 0 auto;text-align:center;padding:3px 12px;background:${e.FINAL_CONFIG.chart.timeTag.backgroundColor};color:${e.FINAL_CONFIG.chart.timeTag.color};font-size:${e.FINAL_CONFIG.chart.timeTag.fontSize}px`)
            }, S(e.timeLabels[i.selectedSerieIndex] || i.selectedSerieIndex), 5)
          ], 8, pa)),
          u("circle", {
            cx: e.drawingArea.left + e.drawingArea.width / e.maxSeries * i.selectedSerieIndex + e.drawingArea.width / e.maxSeries / 2,
            cy: e.drawingArea.bottom,
            r: e.FINAL_CONFIG.chart.timeTag.circleMarker.radius,
            fill: e.FINAL_CONFIG.chart.timeTag.circleMarker.color
          }, null, 8, za)
        ])) : h("", !0)
      ])) : h("", !0),
      G(t.$slots, "svg", { svg: e.svg }, void 0, !0)
    ], 14, qe)) : h("", !0),
    t.$slots.watermark ? (r(), l("div", Ma, [
      G(t.$slots, "watermark", B(Y({ isPrinting: i.isPrinting || i.isImaging })), void 0, !0)
    ])) : h("", !0),
    e.isDataset ? h("", !0) : (r(), R(L, {
      key: 4,
      config: {
        type: "line",
        style: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          line: {
            axis: {
              color: e.FINAL_CONFIG.chart.grid.stroke
            },
            path: {
              color: e.FINAL_CONFIG.chart.grid.stroke,
              strokeWidth: 0.5
            }
          }
        }
      }
    }, null, 8, ["config"])),
    e.FINAL_CONFIG.chart.zoom.show && i.maxX > 6 && e.isDataset ? (r(), R(M, {
      ref: "chartSlicer",
      key: `slicer_${i.slicerStep}`,
      background: e.FINAL_CONFIG.chart.zoom.color,
      fontSize: e.FINAL_CONFIG.chart.zoom.fontSize,
      useResetSlot: e.FINAL_CONFIG.chart.zoom.useResetSlot,
      labelLeft: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[i.slicer.start],
      labelRight: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[i.slicer.end - 1],
      textColor: e.FINAL_CONFIG.chart.color,
      inputColor: e.FINAL_CONFIG.chart.zoom.color,
      selectColor: e.FINAL_CONFIG.chart.zoom.highlightColor,
      borderColor: e.FINAL_CONFIG.chart.backgroundColor,
      minimap: e.minimap,
      smoothMinimap: e.FINAL_CONFIG.chart.zoom.minimap.smooth,
      minimapSelectedColor: e.FINAL_CONFIG.chart.zoom.minimap.selectedColor,
      minimapSelectionRadius: e.FINAL_CONFIG.chart.zoom.minimap.selectionRadius,
      minimapLineColor: e.FINAL_CONFIG.chart.zoom.minimap.lineColor,
      minimapSelectedColorOpacity: e.FINAL_CONFIG.chart.zoom.minimap.selectedColorOpacity,
      minimapSelectedIndex: i.selectedSerieIndex,
      minimapIndicatorColor: e.FINAL_CONFIG.chart.zoom.minimap.indicatorColor,
      max: i.maxX,
      min: 0,
      valueStart: i.slicer.start,
      valueEnd: i.slicer.end,
      start: i.slicer.start,
      "onUpdate:start": s[2] || (s[2] = (a) => i.slicer.start = a),
      end: i.slicer.end,
      "onUpdate:end": s[3] || (s[3] = (a) => i.slicer.end = a),
      onReset: e.refreshSlicer,
      onTrapMouse: e.selectMinimapIndex
    }, {
      "reset-action": z(({ reset: a }) => [
        G(t.$slots, "reset-action", B(Y({ reset: a })), void 0, !0)
      ]),
      _: 3
    }, 8, ["background", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "borderColor", "minimap", "smoothMinimap", "minimapSelectedColor", "minimapSelectionRadius", "minimapLineColor", "minimapSelectedColorOpacity", "minimapSelectedIndex", "minimapIndicatorColor", "max", "valueStart", "valueEnd", "start", "end", "onReset", "onTrapMouse"])) : h("", !0),
    e.FINAL_CONFIG.chart.legend.show ? (r(), l("div", {
      key: 6,
      ref: "chartLegend",
      class: "vue-ui-xy-legend",
      style: A(`font-size:${e.FINAL_CONFIG.chart.legend.fontSize}px`)
    }, [
      (r(!0), l(m, null, I(e.absoluteDataset, (a, c) => (r(), l("div", {
        key: `div_legend_item_${c}`,
        onClick: (n) => e.segregate(a),
        class: P({ "vue-ui-xy-legend-item": !0, "vue-ui-xy-legend-item-segregated": i.segregatedSeries.includes(a.id) })
      }, [
        i.icons[a.type] === "line" ? (r(), l("svg", Ta, [
          u("rect", {
            x: "0",
            y: "7",
            rx: "3",
            stroke: "none",
            height: "4",
            width: "20",
            fill: a.color
          }, null, 8, Va),
          X(f, {
            plot: { x: 10, y: 9 },
            radius: 4,
            color: a.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(a.shape) ? a.shape : "circle",
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            strokeWidth: 1
          }, null, 8, ["color", "shape", "stroke"])
        ])) : (r(), l("svg", Ra, [
          i.icons[a.type] === "bar" ? (r(), l("rect", {
            key: 0,
            x: "0",
            y: "0",
            rx: "1",
            height: "12",
            width: "12",
            stroke: "none",
            fill: a.color
          }, null, 8, Da)) : (r(), R(f, {
            key: 1,
            plot: { x: 6, y: 6 },
            radius: 5,
            color: a.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(a.shape) ? a.shape : "circle"
          }, null, 8, ["color", "shape"]))
        ])),
        u("span", {
          style: A(`color:${e.FINAL_CONFIG.chart.legend.color}`)
        }, S(a.name), 5)
      ], 10, Pa))), 128))
    ], 4)) : (r(), l("div", Wa, [
      G(t.$slots, "legend", { legend: e.absoluteDataset }, void 0, !0)
    ], 512)),
    X(w, {
      show: i.mutableConfig.showTooltip && i.isTooltip,
      backgroundColor: e.FINAL_CONFIG.chart.tooltip.backgroundColor,
      color: e.FINAL_CONFIG.chart.tooltip.color,
      fontSize: e.FINAL_CONFIG.chart.tooltip.fontSize,
      borderRadius: e.FINAL_CONFIG.chart.tooltip.borderRadius,
      borderColor: e.FINAL_CONFIG.chart.tooltip.borderColor,
      borderWidth: e.FINAL_CONFIG.chart.tooltip.borderWidth,
      backgroundOpacity: e.FINAL_CONFIG.chart.tooltip.backgroundOpacity,
      position: e.FINAL_CONFIG.chart.tooltip.position,
      offsetY: e.FINAL_CONFIG.chart.tooltip.offsetY,
      parent: t.$refs.chart,
      content: e.tooltipContent,
      isCustom: e.FINAL_CONFIG.chart.tooltip.customFormat && typeof e.FINAL_CONFIG.chart.tooltip.customFormat == "function"
    }, {
      "tooltip-before": z(() => [
        G(t.$slots, "tooltip-before", B(Y({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      "tooltip-after": z(() => [
        G(t.$slots, "tooltip-after", B(Y({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      _: 3
    }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
    e.isDataset ? (r(), R(C, {
      key: 8,
      hideDetails: "",
      config: {
        open: i.mutableConfig.showTable,
        maxHeight: 1e4,
        body: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        },
        head: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        }
      }
    }, {
      content: z(() => [
        u("div", {
          style: A(`${i.isPrinting ? "" : "max-height:400px"};overflow:auto;width:100%;margin-top:48px`)
        }, [
          u("div", Ha, [
            De(u("input", {
              type: "checkbox",
              "onUpdate:modelValue": s[4] || (s[4] = (a) => i.showSparklineTable = a)
            }, null, 512), [
              [We, i.showSparklineTable]
            ]),
            u("div", {
              onClick: s[5] || (s[5] = (a) => i.showSparklineTable = !i.showSparklineTable),
              style: { cursor: "pointer" }
            }, [
              X(p, {
                name: "chartLine",
                size: 20,
                stroke: e.FINAL_CONFIG.chart.color
              }, null, 8, ["stroke"])
            ])
          ]),
          i.showSparklineTable ? (r(), R(v, {
            key: `sparkline_${i.segregateStep}`,
            dataset: e.tableSparklineDataset,
            config: e.tableSparklineConfig
          }, null, 8, ["dataset", "config"])) : (r(), R(F, {
            key: `table_${i.tableStep}`,
            colNames: e.dataTable.colNames,
            head: e.dataTable.head,
            body: e.dataTable.body,
            config: e.dataTable.config,
            title: `${e.FINAL_CONFIG.chart.title.text}${e.FINAL_CONFIG.chart.title.subtitle.text ? ` : ${e.FINAL_CONFIG.chart.title.subtitle.text}` : ""}`,
            onClose: s[6] || (s[6] = (a) => i.mutableConfig.showTable = !1)
          }, {
            th: z(({ th: a }) => [
              u("div", { innerHTML: a }, null, 8, Ea)
            ]),
            td: z(({ td: a }) => [
              He(S(isNaN(Number(a)) ? a : e.dataLabel({
                p: e.FINAL_CONFIG.chart.labels.prefix,
                v: a,
                s: e.FINAL_CONFIG.chart.labels.suffix,
                r: e.FINAL_CONFIG.table.rounding
              })), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ], 4)
      ]),
      _: 1
    }, 8, ["config"])) : h("", !0)
  ], 14, Xe);
}
const li = /* @__PURE__ */ Ee(Ye, [["render", Ba], ["__scopeId", "data-v-0b37e892"]]);
export {
  li as default
};
